      ///////////////////////////////////////////////
     // CLOCK_MUX.V Version 1.0                   //
    // This is an example of an instantiation of //
   // global buffer (BUFGS) from an internally  //
  // driven signal, a multipled clock.         //
 // September 1997                            //
///////////////////////////////////////////////

module clock_mux (DATA, SEL, SLOW_CLOCK, FAST_CLOCK, DOUT);

    input  DATA, SEL;
    input  SLOW_CLOCK, FAST_CLOCK;
    output DOUT;

    reg   CLOCK;
    wire   CLOCK_GBUF;
    reg    DOUT;

    always @ (SEL)
    begin
        if (SEL == 1'b1)
            CLOCK <= FAST_CLOCK;
        else
            CLOCK <= SLOW_CLOCK;
    end

    BUFGS GBUF_FOR_MUX_CLOCK (.O(CLOCK_GBUF), .I(CLOCK));

    always @ (posedge CLOCK_GBUF)
        DOUT = DATA;

endmodule
